Subject: Re: [netmod] Conflicting usage scenario for "invalid-value" error-tag between RFC 6241 & RFC 6020

From: Peipei Guo <[email-masked]>
Date: Mon, 13 Feb 2017 08:13:48 +0000

Hi Kent,

Your conclusion is conflict with the above analysis. So do you means YANG RFC7950/6020 should be correct, RFC6241 is wrong and should fix it. Right?

Regards,
Peipei Guo

发件人: Kent Watsen
已发送: 2月11日星期六 上午2:56
主题: Re: [netmod] Conflicting usage scenario for "invalid-value" error-tag between RFC 6241 & RFC 6020
收件人: Rohit pobbathi, [email-masked]

Hi Rohit,

On one hand, this seems like a protocol issue, so opting for NETCONF's definitions makes sense.   On the other hand, RFC 6241 is just defining the error-tag without mandating when it's used, whereas RFC 7950 is specifying when it's to be used, so opting for YANG's normative language makes sense (it does no harm).

Personally, I think YANG got it wrong and so it should be fixed there.

Kent // as a contributor

On 2/10/17, 9:25 AM, "Rohit pobbathi" <[email-masked]<mailto:[email-masked]>> wrote:

Hi,

Repeating a query about RFC Section conflict for the usage of error-tag usage during leaf data value mismatch in range/length/pattern.

RFC 6241 Appendix A.  NETCONF Error List – provides the below description for “invalid-value” & “bad-element”

   error-tag:         invalid-value

   error-type:       protocol, application

   error-severity: error

   error-info:       none

   Description:    The request specifies an unacceptable value for one

                             or more parameters.

   error-tag:         bad-element

   error-type:       protocol, application

   error-severity: error

   error-info:        <bad-element> : name of the element w/ bad value

   Description:     An element value is not correct; e.g., wrong type,

                              out of range, pattern mismatch.

RFC 6020 Section 8.3.1.  Payload Parsing

   o  If a leaf data value does not match the type constraints for the

      leaf, including those defined in the type's "range", "length", and

      "pattern" properties, the server MUST reply with an

      "invalid-value" error-tag in the rpc-error, and with the error-

      app-tag and error-message associated with the constraint, if any

      exist.

For leaf data value mismatch in range/length/pattern there is conflict in the error-tag suggested by RFC 6241 & RFC 6020.

Please confirm which is the right error-tag to be used in a standard Netconf Server implementation.

Regards,

Rohit Pobbathi

---

From: Kent Watsen <[email-masked]>
Date: Mon, 13 Feb 2017 15:34:20 +0000

By "personally, I think YANG got it wrong and so it should be fixed there", I'm suggesting that this might be RFC 7950/6020 errata.   But it is just my opinion, whether it matches group consensus remains to be seen...

Kent

On 2/13/17, 3:13 AM, "Peipei Guo" <[email-masked]<mailto:[email-masked]>> wrote:

Hi Kent,

Regards,
Peipei Guo

发件人: Kent Watsen
已发送: 2月11日星期六 上午2:56

Hi Rohit,

Kent // as a contributor

Hi,

   error-tag:         invalid-value

   error-severity: error

   error-info:       none

                             or more parameters.

   error-tag:         bad-element

   error-severity: error

      exist.

Regards,

Rohit Pobbathi

---

From: "Guopeipei (Peipei Guo)" <[email-masked]>
Date: Tue, 14 Feb 2017 08:24:39 +0000

Thanks Kent. My personally opinion is: it might be RFC6241’s errata. The reasons are:
1. RFC6020/7950 is more clear than RFC6241 for the usage of error-tag. And it is a MUST rule for Payload Parsing in YANG 1.0 and YANG 1.1.
2. RFC6241 is just give it as the example when define the well-known error-tag “invalid-value” and “bad-element”.

Hi Andy, Eric,
What is your opinion?

Regards,
Peipei Guo
发件人: netmod [mailto:[email-masked]] 代表 Kent Watsen
发送时间: 2017年2月13日 23:34
收件人: Peipei Guo; Rohit pobbathi; [email-masked]
主题: Re: [netmod] Conflicting usage scenario for "invalid-value" error-tag between RFC 6241 & RFC 6020

Kent

Hi Kent,

Regards,
Peipei Guo

发件人: Kent Watsen
已发送: 2月11日星期六 上午2:56
主题: Re: [netmod] Conflicting usage scenario for "invalid-value" error-tag between RFC 6241 & RFC 6020
收件人: Rohit pobbathi, [email-masked]<mailto:[email-masked]>

Hi Rohit,

Kent // as a contributor

Hi,

   error-tag:         invalid-value

   error-severity: error

   error-info:       none

                             or more parameters.

   error-tag:         bad-element

   error-severity: error

      exist.

Regards,

Rohit Pobbathi